// 002 u_html
// 05 nov 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_html;
  interface
    uses u_c_basic_object;

    function f_html_remove_ampersand_string(p_string: String): String;

  implementation
    uses SysUtils
        , u_c_display
        ;

    function f_html_remove_ampersand_string(p_string: String): String;
      var l_index, l_length: Integer;

      function f_replace(p_coding: String; p_replacement: Char; var pv_string: String): Boolean;
        var l_find_index, l_coding_length: Integer;
        begin
          Result:= (l_index+ Length(p_coding)<= l_length);

          if Result
            then begin
                l_coding_length:= Length(p_coding);
                for l_find_index:= 1 to l_coding_length do
                  if pv_string[l_index+ l_find_index]<> p_coding[l_find_index]
                    then begin
                        // display('not_found '+ p_coding+ ' at '+ IntTostr(l_index));
                        Result:= False;
                        Exit;
                      end;

                // display('  replace_at '+ IntTostr(l_index));
                Delete(pv_string, l_index+ 1, l_coding_length);
                pv_string[l_index]:= p_replacement;
                Dec(l_length, l_coding_length);
              end;
        end; // f_replace

      begin // f_remove_ampersand_string
        display('> f_remove_&');
        Result:= p_string;

        l_index:= 1; l_length:= Length(p_string);
        while l_index<= l_length do
        begin
          if Result[l_index]= '&'
            then begin
                if f_replace('lt;', '<', Result)
                    or f_replace('gt;', '>', Result)
                    or f_replace('quot;', '"', Result)
                    or f_replace('nbsp;', ' ', Result)
                    or f_replace('amp;', '&', Result)
                    // todo: other  &amp, &nbsp etc
                  then
                  else Inc(l_index);
              end
            else Inc(l_index);
        end; // while l_index
        display('< f_remove_&');
      end; // f_remove_ampersand_string

    begin // u_zzz
    end. // u_zzz
